/* HiGroupEditor */

#import <Cocoa/Cocoa.h>

#define	kGroupIconFolder	@"GroupIcons"
#define	kTempFolderPath		@"/.TempGroup.tmp"
#define	kPresentIconIndex	0
#define	kDefaultIconIndex	1
#define kCustomIconIndex	2
#define	kFixedIconMenuItems	3

#define	Key_IconName		@"name"
#define Key_IconImage		@"image"

@interface HiGroupEditor : NSObject
{
    IBOutlet id cancelButton;
    IBOutlet id editPanel;
    IBOutlet id executeButton;
    IBOutlet id nameText;
    IBOutlet id office;
    IBOutlet id webloc;
	IBOutlet id board;
	IBOutlet id iconMenuPopUp;
//	IBOutlet id	colorLabel;
	
	BOOL		editNameMode;
	NSImage		*iconImage;
	NSImage		*customImage;			//カスタムアイコンイメージ
	NSImage		*defaultFolderImage;	//デフォルトフォルダのイメージ
	NSMutableArray	*iconArray;		//名前とイメージの辞書の配列
}

//********************
// 初期化等
//********************

- (void)awakeFromNib;
- (void)initIconArray;
- (void)dealloc;


//********************
// アクション等
//********************

- (void)actNoChangeIconImage:(id)sender;
- (void)actDefaultIconImage:(id)sender;
- (void)actCustomIconImage:(id)sender;
- (void)actChangeIconImage:(id)sender;
- (void)actEditNewGroup:(id)sender;	//メニューの新規グループ作成
- (void)actEditGroupName:(id)sender;	//メニューのグループ名変更
- (IBAction)actExecute:(id)sender;	//実行ボタンが押された

//*************
// ユーティリティ
//*************

- (void)editStart;	//編集開始
- (BOOL)executeNewGroup:(NSString *)groupName;	//新規グループの実行
- (BOOL)executeChangeName:(NSString *)groupName;	//グループ名変更の実行
- (void)executeEnd;
- (IBAction)actCancel:(id)sender;
- (void)editEnd;	//パネルを閉じる
- (BOOL)createNewGroup:(NSString *)groupName;	//groupName名のグループ（フォルダ）を作成する
- (BOOL)changeGroupName:(NSString *)groupName;	//グループ名の変更
- (BOOL)insertEmptyGroupAtGroup:(NSMutableArray *)group
					   pointItem:(NSString *)pointItem
					 insertGroup:(NSString *)groupItem;	//空のグループをgroupグループ内のpointItemの前に挿入する
- (BOOL)appendEmptyGroupAtGroup:(NSMutableArray *)group
					insertGroup:(NSString *)insertItem; //空のグループををgroupグループ内の最後尾に追加する
- (void)replaceGroupNameAtGroup:(NSMutableArray *)groupList
						oldName:(NSString *)oldName
						newName:(NSString *)newName;	//指定のグループ名を変更する
- (void)resetIconArray:(NSArray *)array;

//********************
// アクセッサ
//********************

- (NSMutableArray *)iconArray;
- (void)windowWillClose:(NSNotification *)aNotification;

@end
