/* HiHTMLMaker */

#import <Cocoa/Cocoa.h>

#define	Def_WriteNoteInTitle	YES
#define	Key_WriteNoteInTitle	@"WriteNoteStringInTitle"

@class HiURLOffice;
@class HiWeblocFile;
@class HiOutlineView;
@class HiURLBoard;

@interface HiHTMLMaker : NSObject
{
	HiURLOffice		*office;
	HiWeblocFile	*webloc;
	HiOutlineView	*dataView;
	HiURLBoard		*board;
	NSPanel			*progressPanel;
	NSTextField		*progressText;
	NSProgressIndicator	*progressIndicator;
	NSWindow		*mainWindow;
	
	//アクセッサあり
	BOOL	writeNoteInTitle;
	
	//内部使用
	BOOL	creatingURL;
	BOOL	creatingHTML;
	BOOL	breakCreateURL;
	BOOL	breakCreateHTML;
}

- (void)dealloc;

//********************
// アクション
//********************

- (void)actSaveHTMLSelectedData:(id)sender;	//選択部分をHTMLで書き出す
- (void)actCreateWindowsURLFile:(id)sender;

//********************
// ユーティリティ
//********************

- (void)createWindowsURLFileThread:(NSString *)winurlPath;
- (BOOL)createWindowsURLFileAt:(NSString *)outputPath
					  withPath:(NSString *)originalPath;
- (NSArray *)pathListAtFolder:(NSString *)path;
- (void)createDirectoryWithPath:(NSString *)path;

- (void)makeHTMLDataMain:(NSFileHandle *)file;	//選択範囲からアイテムリストを作成しHTML出力処理する
- (void)writeGroupDataToFile:(NSFileHandle *)file
				   groupItem:(NSString *)groupItem
					  indent:(int *)indent;
- (void)writeURLDataToFile:(NSFileHandle *)file
				 groupName:(NSString *)groupName
				   urlName:(NSString *)urlName
					indent:(int)indent;			//URL名とリンク先、備考を書き込む
- (void)writeBlockquoteToFile:(NSFileHandle *)file indent:(int)indent;
- (void)writeCloseBlockquoteToFile:(NSFileHandle *)file indent:(int)indent;
- (void)writeGroupName:(NSString *)groupName toFile:(NSFileHandle *)file indent:(int)indent;
- (void)writeCloseDataListToFile:(NSFileHandle *)file indent:(int)indent;

//********************
// デリゲートメソッド
//********************

- (BOOL)validateMenuItem:(NSMenuItem*)item;	//メニューのイネーブル設定

//********************
// 実行状況表示関係
//********************

- (void)startCreateHTMLProgress;
- (void)sheetDidEnd:(NSWindow *)sheet
		 returnCode:(int)returnCode
		contextInfo:(void *)contextInfo;
- (void)startCreateURLProgress;
//- (void)stopProgress;

//********************
// アクセッサ
//********************

- (BOOL)writeNoteInTitle;
- (void)setWriteNoteInTitle:(BOOL)inBool;

@end
