/* HiPreferences */

#import <Cocoa/Cocoa.h>

@class HiURLOffice;
@class HiWeblocFile;
@class HiCommenter;
@class HiColorLabel;
@class HiURLCenter;
@class HiHTMLMaker;

@interface HiPreferences : NSObject
{
	HiURLOffice *office;
	HiWeblocFile *webloc;
	HiCommenter	*commenter;
	HiColorLabel	*labeler;		//ラベル機能、カラータイトル機能
	HiURLCenter	*center;
	HiHTMLMaker	*maker;
	IBOutlet id	utility;
	IBOutlet id watcher;
	
	NSButton	*executeButton;
	NSButton	*cancelButton;
	NSPanel		*prefPanel;
	NSTextField		*indentText;
	NSTextField		*maxItemsText;
	NSButton	*autoExpandButton;
	NSButton	*renewAwakeCheck;
	NSTextField	*timeoutSecondsText;
	NSButton	*writeCommentCheck;
	NSTextField	*label1NameText;
	NSTextField	*label2NameText;
	NSTextField	*label3NameText;
	NSTextField	*label4NameText;
	NSTextField	*label5NameText;
	NSTextField	*label6NameText;
	NSTextField	*label7NameText;
	NSTextField	*menuFolderText;
	NSTextField	*startupFolderText;
	NSButton	*startupSetOnlyCheck;
	NSButton	*menuSetOnlyCheck;
	NSTextField	*colorNameText1;
	NSTextField	*colorNameText2;
	NSTextField	*colorNameText3;
	NSTextField	*colorNameText4;
	NSTextField	*colorNameText5;
	NSTextField	*colorNameText6;
	NSTextField	*colorNameText7;
	NSButton	*noLabelCheck;			//ラベル機能を使用しないチェックボックス
	NSButton	*noColorCheck;			//カラータイトル機能を使用しないチェックボックス
//-------------------------------v182
	id			initStartCheck;			//起動時にカラーラベルを初期化するチェックボックス
//-----------------------------------
	NSButton	*writeNoteCheck;
	NSTextField *browserText;
	NSTextField *fileBrowserText;
//----------------------------v180
	id	fileEditorText;
	id	pdfReaderText;
	id	docEditorText;
//----------------------------v210
	id	pictureViewerText;
	id	moviePlayerText;
	id	soundPlayerText;
//--------------------------------
	NSTextField	*historyCountMaxText;
	NSButton	*watchSwitchCheck;
	NSTextField	*watchIntervalText;
	NSTextField	*accessIntervalText;
	IBOutlet id selectExecMaxText;
	
	NSString	*dataFolder;		//データフォルダまでのフルパス名
	float	indentWidth;
	int		maxItems;
	BOOL	autoExpand;
	BOOL	renewAwake;				//起動時データフォルダ一覧表のチェックをするかどうかのフラグ
	int		timeoutSeconds;
	BOOL	writeComment;			//ＵＲＬ等をコメントに書き込むかどうかのフラグ
	NSString	*label1Name;
	NSString	*label2Name;
	NSString	*label3Name;
	NSString	*label4Name;
	NSString	*label5Name;
	NSString	*label6Name;
	NSString	*label7Name;
	NSString	*defaultBrowser;
	NSString	*fileBrowser;
//-----------------------------v180
	NSString	*fileEditor;
	NSString	*pdfReader;
	NSString	*docEditor;
//-----------------------------v210
	NSString	*pictureViewer;
	NSString	*moviePlayer;
	NSString	*soundPlayer;
//---------------------------------
	int			historyCountMax;
	NSString	*menuFolder;
	NSString	*startupFolder;
	BOOL		startupSetOnly;
	BOOL		menuSetOnly;
	NSString	*colorName1;
	NSString	*colorName2;
	NSString	*colorName3;
	NSString	*colorName4;
	NSString	*colorName5;
	NSString	*colorName6;
	NSString	*colorName7;
	BOOL		noLabel;			//ラベル機能を使用しない
	BOOL		noColor;			//カラータイトル機能を使用しない
	//-----------------------------v182,v210
//	BOOL		initStart;			//起動時にカラーラベルを初期化する
	//---------------------------------
	BOOL		writeNoteInTitle;	//
	BOOL		watchSwitch;		//定期更新チェック
	float		watchInterval;		//定期更新間隔
	int			selectExecMax;		//選択して実行時の最大実行項目数
	double		accessInterval;
}

- (void)dealloc;


- (void)renewalControlState;
- (void)prefFinish;

- (void)actPreferences:(id)sender;
- (void)actPrefExecute:(id)sender;
- (void)actPrefCancel:(id)sender;
- (void)actUsual:(id)sender;
- (void)actSelectMenuFolder:(id)sender;
- (void)actSelectStartupFolder:(id)sender;
- (void)actCancelMenuFolder:(id)sender;
- (void)actCancelStartupFolder:(id)sender;
- (void)actSystemDefaultBrowser:(id)sender;
- (void)actSystemFileBrowser:(id)sender;
- (void)actSelectDefaultBrowser:(id)sender;
- (void)actSelectFileBrowser:(id)sender;
//-------------------------------------v180
- (void)actSystemEditor:(id)sender;
- (void)actSelectFileEditor:(id)sender;
- (void)actSystemReader:(id)sender;
- (void)actSelectReader:(id)sender;
- (void)actSystemDocEditor:(id)sender;
- (void)actSelectDocEditor:(id)sender;
//-------------------------------------v210
- (void)actSystemPictureViewer:(id)sender;
- (void)actSelectPictureViewer:(id)sender;
- (void)actSystemMoviePlayer:(id)sender;
- (void)actSelectMoviePlayer:(id)sender;
- (void)actSystemSoundPlayer:(id)sender;
- (void)actSelectSoundPlayer:(id)sender;
//-----------------------------------------

- (NSString *)selectMenuFolder;
- (NSString *)selectStartupFolder;
- (id)selectBrowser;
//-------------------v180
- (id)selectEditor;
- (id)selectReader;
- (id)selectDocEditor;
- (id)defaultSelectorWithTitle:(NSString *)title;
//-------------------v210
- (id)selectPictureViewer;
- (id)selectMoviePlayer;
- (id)selectSoundPlayer;
//-----------------------
- (void)windowWillClose:(NSNotification *)aNotification;

@end
