/* HiURLManager */

#import <Cocoa/Cocoa.h>

//#define SleepTimeForAccessLoop	5.0	//アクセスループ時に次のアクセスまで待つ時間

#define Name_MainWindow		@"MainWindowFrame"
#define Name_SearchPanel	@"SearchPanelFrame"
#define Name_URLEditPanel	@"URLEditPanelFrame"
#define Name_NoteEditPanel	@"NoteEditPanelFrame"
#define Name_GroupEditPanel	@"GroupEditPanelFrame"
#define Name_DuplicatePanel	@"DuplicatePanelFrame"
#define	Name_RenewaledPanel	@"RenewaledPanel"
#define Name_PrefsPanel		@"PreferencesPanel"
#define Name_AllListPanel	@"AllURLListPanel"

#define Name_GroupIconEdit	@"GroupIconEditPanel"
#define Note_ItemDeleted		@"ItemIsDeletedNotification"
#define Note_DuplicateChecked	@"DuplicateCheckedNotification"
#define	Note_ItemSearched		@"ItemSearchedNotification"

#define Def_StartupFolder	@""
#define Key_StartupFolder	@"StartupFolderName"
#define Def_MenuFolder		@""
#define Key_MenuFolder		@"MenuFolderName"
#define Def_WindowState		YES
#define Key_WindowState		@"MainWindowState"
#define Def_MenuSetOnly		NO
#define Key_MenuSetOnly		@"MenuSetOnlyFlag"
#define Def_StartupSetOnly	NO
#define Key_StartupSetOnly	@"StartupSetOnlyFlag"
#define	Key_LastMenuItem	@"LastMenuItems"
#define	Key_StatusItemMenu	@"StatusItemMenu"
#define	Key_MenuItemTitle	@"MenuItemTitle"
#define	Key_MenuItemIcon	@"MenuItemIcon"
#define	Key_MenuItemColor	@"ManuItemColor"
#define	Key_MenuItemLabel	@"ManuItemLabel"
#define	Key_MenuItemToolTip	@"MenuItemToolTip"
#define	Def_AccessInterval	1.0	//アクセスループ時に次のアクセスまで待つ時間
#define	Key_AccessInterval	@"AccessIntervalTime"

#define	Def_Encoding		NSShiftJISStringEncoding


enum {
	breakOFF	= 0,
	breakREADY	= 1,
	breakON		= 2
};

enum {
	OPENWINDOW_ITEMTAG	= 1,
	REDOSTARTUP_ITEMTAG	= 2,
	TEXTCOLOR_ITEMTAG	= 3,
	COLORCANCEL_ITEMTAG	= 4,
	ALLLIST_ITEMTAG		= 5
};

@class HiURLBoard;
@class HiURLOffice;
@class HiURLEditor;
@class HiGroupEditor;
@class HiNoteEditor;
@class HiOutlineView;
@class HiURLBoard;
@class HiWeblocFile;
@class HiColorLabel;
@class HiRenewalWatcher;

@interface HiURLCenter : NSObject// <NSTableViewDataSource>
{
	//InterfaceBuilderで設定
	NSWindow		*mainWindow;
	HiURLOffice		*office;		//一覧表を管理
	HiURLEditor		*urlEditor;
	HiGroupEditor	*groupEditor;
	HiNoteEditor	*noteEditor;
	HiOutlineView	*dataView;		//情報資源表示ビュー
	HiURLBoard		*board;
	HiWeblocFile	*webloc;
	HiColorLabel	*labeler;
	//---------------------------v220
	id				watcher;
	//-------------------------------
	id				updater;
	//-----------v2.00
	id	shareLib;
	//----------------
	
	NSPanel			*searchPanel;
	NSPanel			*duplicatePanel;
	NSPanel			*urlEditPanel;
	NSPanel			*noteEditPanel;
	NSPanel			*groupEditPanel;
	NSPanel			*renewaledPanel;
	NSPanel			*allListPanel;
	NSMenu			*statusMenu;
	id				startupPanel;
	id				startupProgress;
	id				labelInitializeText;
	id				labelCancelButton;
	
	NSString		*startupFolder;
	NSString		*menuFolder;		//メニューアイテムフォルダ
	NSMenu			*statusItemMenu;
	NSStatusItem	*statusItem;	//ステータスアイテム
	int				firstItems;
	BOOL			startupSetOnly;
	BOOL			menuSetOnly;
	double			accessInterval;
}

//********************
// 初期化等
//********************

+ (void)initialize;
- (void)awakeFromNib;
- (void)dealloc;

//********************
// デリゲート
//********************

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification;
- (void)applicationWillTerminate:(NSNotification *)aNotification;
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender;
- (void)applicationDidBecomeActive:(NSNotification *)aNotification;
- (BOOL)applicationShouldHandleReopen:(NSApplication *)theApplication hasVisibleWindows:(BOOL)flag;
- (BOOL)validateMenuItem:(NSMenuItem*)item;	//メニューのイネーブル設定

//********************
// アクション
//********************

- (void)actChangeWindow:(id)sender;		//「メイン画面を開く／閉じる」メニュー
- (void)actRedoStartup:(id)sender;		//起動時実行フォルダの再実行
- (void)actSubMenu:(id)sender;			//アイテムメニューのフォルダメニューを選択するとここに来る
- (void)actItemMenu:(id)sender;			//アイテムメニューの項目を選択するとここに来る
- (void)actRestructMenu:(id)sender;		//ステータスメニューをセットする
- (void)actSetColorText:(id)sender;		//テキスト色の設定
- (void)actChangeColor:(id)sender;		//テキスト色の変更
- (void)actCancelColorText:(id)sender;	//テキスト色を黒にする
- (void)actDispAtFinder:(id)sender;		//選択アイテムをファインダーのウインドウに表示する
//---------------------------------------v181
- (void)actEditNameOrData:(id)sender;	//グループ名または情報資源の編集
- (void)actCopyName:(id)sender;			//グループ名または情報資源名のコピー
- (void)actCopyNote:(id)sender;			//備考文字列のコピー
//---------------------------------------

//********************
// ユーティリティ
//********************

- (void)makeMenuThread:(id)argument;
- (void)changeTitleColor:(NSColor *)color;
- (void)openStartupItems;
- (NSMenu *)itemMenuWithItemList:(NSArray *)itemList
						   title:(NSString *)title
					   menuArray:(NSMutableArray *)inMenuArray;
- (BOOL)displayFile:(NSString *)filePath;
- (void)saveWindowState;
- (NSMenu *)remakeStatusItemMenu:(NSArray *)inMenuArray;
- (NSMenu *)itemMenuWithArray:(id)inArray menu:(NSMenu *)inMenu;


//********************
// アクセッサ
//********************

- (NSString *)startupFolder;
- (void)setStartupFolder:(NSString *)inStartup;
- (NSString *)menuFolder;
- (void)setMenuFolder:(NSString *)inMenu;
- (BOOL)startupSetOnly;
- (void)setStartupOnly:(BOOL)inBool;
- (BOOL)menuSetOnly;
- (void)setMenuSetOnly:(BOOL)inBool;
- (double)accessInterval;
- (void)setAccessInterval:(double)interval;
- (NSStatusItem *)statusItem;

@end
